// Developed by Fabrice Bline
// Cemagref
// Aout 2004
function [x,y,typ]=IAP_Cycle(job,arg1,arg2)
x=[];y=[];typ=[]
select job
case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)
case 'set' then
  x=arg1
  graphics=arg1.graphics;exprs=graphics.exprs
  model=arg1.model;
  while %t do
    [ok,P1,P2,P3,P4,exprs]=getvalue('Cycle characteristics',..
	['Phase 1 [Time(hrs);Feed(0/1);Aeration(0/1);Withdrawal(0/1)]';
	'Phase 2 [Time(hrs);Feed(0/1);Aeration(0/1);Withdrawal(0/1)]';
	'Phase 3 [Time(hrs);Feed(0/1);Aeration(0/1);Withdrawal(0/1)]';
	'Phase 4 [Time(hrs);Feed(0/1);Aeration(0/1);Withdrawal(0/1)]'],..
	    list('vect',4,..
	    'vec',4,..
	    'vec',4,..
	    'vec',4),..
	    exprs)
    if ~ok then break,end
    if ok then
	graphics.exprs=exprs;
	rpar=[P1;P2;P3;P4];
	model.rpar=rpar
	x.graphics=graphics;x.model=model
	break
    end
  end
case 'define' then
  P1=[1;1;0;0];
  P2=[9;0;0;0];
  P3=[13;0;1;0];
  P4=[1;0;1;1];
  in=[];out=3

  model=scicos_model()
  model.sim=list('IAP_Cycle',1)
  model.in=in
  model.out=out
  model.evtin=1
  model.rpar=[P1;P2;P3;P4];
  model.blocktype='c'
  model.dep_ut=[%f %t]

  exprs=[strcat(sci2exp(P1));
	 strcat(sci2exp(P2));
	 strcat(sci2exp(P3));
	 strcat(sci2exp(P4))]
  gr_i=list(['thick=xget(''thickness'');';
	'pat=xget(''pattern'');';
	'fnt=xget(''font'');';
	'xset(''font'',fnt(1),2);';
 	'xset(''pattern'',scs_color(1));';
 	'xset(''pattern'',scs_color(2));';
	'xset(''font'',fnt(1),4);';
	'xstringb(orig(1)+0.5*sz(1),orig(2)+0.5*sz(2),''IAP Cycle'',0,0);';
	'xset(''font'',fnt(1),1);';
	'xset(''pattern'',pat);'],3)
  x=standard_define([4 2],model,exprs,gr_i)
end
endfunction
