// Developed by Fabrice Bline
// Cemagref
// Aout 2004
function [x,y,typ]=Influent_PiWaT1(job,arg1,arg2)
x=[];y=[];typ=[]
select job
case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)
case 'set' then
  x=arg1
  graphics=arg1.graphics;
  exprs=graphics.exprs;
  model=arg1.model;

  exprs1=[exprs(1)];
  exprs2=[exprs(2); exprs(3); exprs(4); exprs(5); exprs(6); exprs(7); exprs(8); exprs(9); exprs(10); exprs(11); exprs(12); exprs(13); exprs(14); exprs(15); exprs(16)];

  n=1;
 
  n=x_choose(['Feed flow rate';'Influent characteristics'],['Menu'])

  if n==1 then,
  while %t do
    [ok,Qa,exprs1]=getvalue('Feed flow rate',..
	['Feed flow rate (m3/h)'],..
	    list('vect',1),..
	    exprs1)
    if ~ok then break,end
    if ok then
	model.rpar(1)=Qa;
	graphics.exprs(1)=exprs1(1);
	x.graphics=graphics;
        x.model=model
	break
    end
  end
 end


 if n==2 then,
  while %t do
    [ok,Si,Ss,Xi,Xs,Xbh,Xbai,Xbaa,Xp,So,Snoi,Snoa,Snh,Snd,Xnd,Xni,exprs2]=getvalue('Influent characteristics',..
	['Soluble inert COD - Si (gDCO/m3)';
	'Readily biodegradable COD - Ss (gDCO/m3)';
	'Particulate inert COD - Xi (gDCO/m3)';
	'Slowly Biodegradable COD - Xs (gDCO/m3)';
	'Active heterotrophic biomass - Xbh (gDCO/m3)';
	'Active ammonium oxidizing biomass - Xbai (gDCO/m3)';
	'Active nitrite oxidizing biomass - Xbaa (gDCO/m3)';
	'Particulate inert COD from biomass - Xp (gDCO/m3)';
	'Dissolved oxygen - So (gO2/m3)';
	'Nitrite - Snoi (gN/m3)';
	'Nitrate - Snoa (gN/m3)';
	'Ammonium+ammonia - Snh (gN/m3)';
	'Soluble organic nitrogen - Snd (gN/m3)';
	'Particulate organic nitrogen - Xnd (gN/m3)';
	'Particulate inert organic nitrogen - Xni (gN/m3)'],..
	    list('vect',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1),..
	    exprs2)
    if ~ok then break,end
    if ok then
	model.rpar(2)=Si;
	model.rpar(3)=Ss;
	model.rpar(4)=Xi;
	model.rpar(5)=Xs;
	model.rpar(6)=Xbh;
	model.rpar(7)=Xbai;
	model.rpar(8)=Xbaa;
	model.rpar(9)=Xp;
	model.rpar(10)=So;
	model.rpar(11)=Snoi;
	model.rpar(12)=Snoa;
	model.rpar(13)=Snh;
	model.rpar(14)=Snd;
	model.rpar(15)=Xnd;
	model.rpar(16)=Xni;
	graphics.exprs(2)=exprs2(1);
	graphics.exprs(3)=exprs2(2);
	graphics.exprs(4)=exprs2(3);
	graphics.exprs(5)=exprs2(4);
	graphics.exprs(6)=exprs2(5);
	graphics.exprs(7)=exprs2(6);
	graphics.exprs(8)=exprs2(7);
	graphics.exprs(9)=exprs2(8);
	graphics.exprs(10)=exprs2(9);
	graphics.exprs(11)=exprs2(10);
	graphics.exprs(12)=exprs2(11);
	graphics.exprs(13)=exprs2(12);
	graphics.exprs(14)=exprs2(13);
	graphics.exprs(15)=exprs2(14);
	graphics.exprs(16)=exprs2(15);
	x.graphics=graphics;
        x.model=model;
	break
    end
  end
 end
case 'define' then
  Qa=20;
  Si=3000;
  Ss=6500;
  Xi=10000;
  Xs=15000;
  Xbh=0;
  Xbai=0;
  Xbaa=0;
  Xp=0;
  So=0;
  Snoi=0;
  Snoa=0;
  Snh=3500;
  Snd=100;
  Xnd=300;
  Xni=500;
  in=3;out=16

  model=scicos_model()
  model.sim=list('Influent_PiWaT1',1)
  model.in=in
  model.out=out
  model.evtin=[]
  model.rpar=[Qa;Si;Ss;Xi;Xs;Xbh;Xbai;Xbaa;Xp;So;Snoi;Snoa;Snh;Snd;Xnd;Xni];
  model.blocktype='c'
  model.dep_ut=[%t %f]

  exprs=[string(Qa);
	 string(Si);
	 string(Ss);
	 string(Xi);
	 string(Xs);
	 string(Xbh);
	 string(Xbai);
	 string(Xbaa);
	 string(Xp);
	 string(So);
	 string(Snoi);
	 string(Snoa);
	 string(Snh);
	 string(Snd);
	 string(Xnd);
	 string(Xni)]
  gr_i=list(['thick=xget(''thickness'');';
	'pat=xget(''pattern'');';
	'fnt=xget(''font'');';
	'xset(''font'',fnt(1),1);';
 	'xset(''pattern'',scs_color(1));';
	'xstringb(orig(1)+0.25*sz(1),orig(2)+0.5*sz(2),''Cycle [3]'',0,0);';
	'xset(''pattern'',scs_color(2));';
	'xset(''font'',fnt(1),2);';
	'xstringb(orig(1)+0.5*sz(1),orig(2)+0.8*sz(2),''IAP Influent'',0,0);';
	'xstringb(orig(1)+0.5*sz(1),orig(2)+0.2*sz(2),''PiWaT1'',0,0);';
	'xset(''font'',fnt(1),1);';
	'xset(''pattern'',pat);'],5)
  x=standard_define([4 4],model,exprs,gr_i)
end
endfunction
