/* Developed by Fabrice Bline */
/* Cemagref */
/* Aout 2004 */

#include "stdio.h"
#include "stdlib.h"
#include "math.h"

#define  Si x[0]
#define  Ss x[1]
#define  Xi x[2]
#define  Xs x[3]
#define  Xbh x[4]
#define  Xbai x[5]
#define  Xbaa x[6]
#define  Xp x[7]
#define  So x[8]
#define  Snoi x[9]
#define  Snoa x[10]
#define  Snh x[11]
#define  Snd x[12]
#define  Xnd x[13]
#define  Xni x[14]
#define  Vr x[15]

#define Yh rpar[0]
#define Yhd rpar[1]
#define Yai rpar[2]
#define Yaa rpar[3]
#define fp rpar[4]
#define ibn rpar[5]


#define muh rpar[6]
#define bh rpar[7]
#define Koh rpar[8]
#define Kad rpar[9]
#define Ks rpar[10]
#define Knoi rpar[11]
#define Knoa rpar[12]
#define ng rpar[13]
#define Knh rpar[14]
#define Kh rpar[15]
#define nh rpar[16]
#define ka rpar[17]

#define muai rpar[18]
#define bai rpar[19]
#define Knai rpar[20]
#define Koai rpar[21]
#define muaa rpar[22]
#define baa rpar[23]
#define Knaa rpar[24]
#define Koaa rpar[25]


#define Alpha rpar[27]
#define Beta rpar[28]

#define Temperature rpar[29]

#define FILE_OUT rpar[31]
#define FILE_IN rpar[32]

#define Qa u1[0]
#define Si_a u1[1]
#define Ss_a u1[2]
#define Xi_a u1[3]
#define Xs_a u1[4]
#define Xbh_a u1[5]
#define Xbai_a u1[6]
#define Xbaa_a u1[7]
#define Xp_a u1[8]
#define So_a u1[9]
#define Snoi_a u1[10]
#define Snoa_a u1[11]
#define Snh_a u1[12]
#define Snd_a u1[13]
#define Xnd_a u1[14]
#define Xni_a u1[15]

#define Feeding u2[0]
#define Aeration u2[1]
#define Withdraw u2[2]

#define Cs Beta*(-0.0000661858*pow(Temperature,3)+0.0075161751*pow(Temperature,2)-0.3999077443*Temperature+14.58958)

#define process1 muh*(Ss/(Ks+Ss))*(So/(Koh+So))*(Snh/(Knh+Snh))*Xbh
#define process2 ng*muh*(Ss/(Ks+Ss))*(Kad/(Kad+So))*(Snh/(Knh+Snh))*(Snoi/(Knoi+Snoi))*(Snoi/(Snoa+Snoi))*Xbh
#define process3 ng*muh*(Ss/(Ks+Ss))*(Kad/(Kad+So))*(Snh/(Knh+Snh))*(Snoa/(Knoa+Snoa))*(Snoa/(Snoa+Snoi))*Xbh
#define process4 muai*(Snh/(Knai+Snh))*(So/(Koai+So))*(Snh/(Knh+Snh))*Xbai
#define process5 muaa*(Snoi/(Knaa+Snoi))*(So/(Koaa+So))*(Snh/(Knh+Snh))*Xbaa
#define process6 bh*Xbh
#define process7 bai*Xbai
#define process8 baa*Xbaa
#define process9 ka*Snd*Xbh
#define process10 Kh*Xs*((So/(Koh+So))+nh*(Kad/(Kad+So))*(Snoi/(Knoi+Snoi)*(Snoi/(Snoa+Snoi)))+nh*(Kad/(Kad+So))*(Snoa/(Knoa+Snoa)*(Snoa/(Snoa+Snoi))))
#define process11 process10*(Xnd/Xs)


void IAPreacteur_PiWaT1(int * flag, int *nevprt, double* t, double* xd, double* x,
	     int* nx, double* z, int *nz, double* tvec, int* ntvec,
	     double* rpar, int* nrpar, int* ipar, int* nipar, double* u1,
	     int* nu1,double* u2, int* nu2, double* y1, int* ny1, double* y2,
	     int* ny2)

{
  float Qs;
  float Kla;
  float temp1,temp2,temp3,temp4,temp5,temp6,temp7,temp8,temp9,temp10,temp11,temp12,temp13,temp14,temp15,temp16;
  FILE *stream;
  char file[]="state.piwat1";



  if (Withdraw==1) 
    { 
      Qs=rpar[30]*24;  
    } 
  else 
    { 
      Qs=0;
    } 
  if (Aeration==1)
    {
      Kla=Alpha*rpar[26]; 
    }
  else 
    {  
      Kla=0;
    } 
 if (*flag==4 && FILE_IN==1)
    {
      /*  Initialisation */
      if ((stream=fopen(file, "r"))==NULL)
	{
	  /*printf("Ouverture du fichier impossible");*/
	  exit(-1); 
	}
      else
	{
	  fscanf(stream, "%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f",&temp1,&temp2,&temp3,&temp4,&temp5,&temp6,&temp7,&temp8,&temp9,&temp10,&temp11,&temp12,&temp13,&temp14,&temp15,&temp16);
	  fclose(stream);
	  Si=temp1;
	  Ss=temp2;
	  Xi=temp3;
	  Xs=temp4;
	  Xbh=temp5;
	  Xbai=temp6;
	  Xbaa=temp7;
	  Xp=temp8;
	  So=temp9;
	  Snoi=temp10;
	  Snoa=temp11;
	  Snh=temp12;
	  Snd=temp13;
	  Xnd=temp14;
	  Xni=temp15;
	  Vr=temp16;
	}
    }
 else
   {
     if (*flag==5 && FILE_OUT==1)
       {
	 /*  Ending */
	 if ((stream=fopen(file, "w"))==NULL)
	   {
	     exit(-1);
	   }
	 else
	   {
	     fprintf(stream,"%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\n",y1[1],y1[2],y1[3],y1[4],y1[5],y1[6],y1[7],y1[8],y1[9],y1[10],y1[11],y1[12],y1[13],y1[14],y1[15],y2[0]);
	     fclose(stream);
	   }

       }
     else
       {
	 if (*flag==1||*flag==6)
	   {
	     y1[0]=Qs;
	     y1[1]=Si;
	     y1[2]=Ss;
	     y1[3]=Xi;
	     y1[4]=Xs;
	     y1[5]=Xbh;
	     y1[6]=Xbai;
	     y1[7]=Xbaa;
	     y1[8]=Xp;
	     y1[9]=So;
	     y1[10]=Snoi;
	     y1[11]=Snoa;
	     y1[12]=Snh;
	     y1[13]=Snd;
	     y1[14]=Xnd;
	     y1[15]=Xni;
	     y2[0]=Vr;
	   }
	 else
	   {
	     if (*flag==0)
	       {
		 xd[0]=Qa*(Si_a-Si)/Vr;
		 xd[1]=Qa*(Ss_a-Ss)/Vr-1/Yh*process1-1/Yhd*process2-1/Yhd*process3+process10;
		 xd[2]=Qa*(Xi_a-Xi)/Vr;
		 xd[3]=Qa*(Xs_a-Xs)/Vr+(1-fp)*process6 +(1-fp)*process7+(1-fp)*process8-process10;
		 xd[4]=Qa*(Xbh_a-Xbh)/Vr+process1 +process2+process3-process6;
		 xd[5]=Qa*(Xbai_a-Xbai)/Vr+process4 -process7;
		 xd[6]=Qa*(Xbaa_a-Xbaa)/Vr+process5 -process8;
		 xd[7]=Qa*(Xp_a-Xp)/Vr+fp*process6 +fp*process7+fp*process8;
		 xd[8]=Qa*(So_a-So)/Vr-((1-Yh)/Yh)*process1 -((3.43-Yai)/Yai)*process4-((1.14-Yaa)/Yaa)*process5 + Kla*(Cs-So);
		 xd[9]=Qa*(Snoi_a-Snoi)/Vr-((1-Yhd)/(1.71*Yhd))*process2+((1-Yhd)/(1.14*Yhd))*process3+1/Yai*process4-1/Yaa*process5;
		 xd[10]=Qa*(Snoa_a-Snoa)/Vr-((1-Yhd)/(1.14*Yhd))*process3+1/Yaa*process5;
		 xd[11]=Qa*(Snh_a-Snh)/Vr-ibn*process1 -ibn*process2-ibn*process3 -(ibn+1/Yai)*process4 -ibn*process5 +process9;
		 xd[12]=Qa*(Snd_a-Snd)/Vr-process9 +process11;
		 xd[13]=Qa*(Xnd_a-Xnd)/Vr+(ibn-fp*ibn)*process6 +(ibn-fp*ibn)*process7+(ibn-fp*ibn)*process8-process11;
		 xd[14]=Qa*(Xni_a-Xni)/Vr+fp*ibn*process6+fp*ibn*process7+fp*ibn*process8;
		 xd[15]=Qa-Qs;
	       }
	   }
       }
   }
 return;
}

